<?php
/**
* @copyright infograf768 and various GPL sources
* @ Unwanted html elements code suggested by ghazal
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* Joomla 1.5 native
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');
$mainframe->registerEvent( 'onPrepareContent', 'plgContentJostag' );



// process plugin events
function plgContentJostag( &$row, &$params, $page=0 ) {
	$db =& JFactory::getDBO();
	// simple performance check to determine whether bot should process further
	if ( JString::strpos( $row->text, 'tag' ) === false ) {
		return true;
	}	


// Get plugin info
	$plugin =& JPluginHelper::getPlugin('content', 'jostag');
	
// define the regular expression for the plugin
	$regex = "#{tag}(.*?){/tag}#s";
	
	// perform the replacement
    $pluginParams = new JParameter( $plugin->params );

// check whether plugin has been unpublished
	if ( !$pluginParams->get( 'enabled', 1 ) ) {
	$row->text = preg_replace( $regex, '', $row->text );
    return true;
     }
	// perform the replacement
    $row->text = preg_replace_callback( $regex, 'plgJosTag_replacer', $row->text );
    return true;
}

// handle plugin replacement
function plgJosTag_replacer ( &$matches) 
{
global $mainframe;
$document	= & JFactory::getDocument();
$plugin =& JPluginHelper::getPlugin('content', 'jostag');
$pluginParams = new JParameter( $plugin->params );
$tag= $matches[1];

  // strip out unwanted HTML elements
  $html_entities_match = array( "|\<br \/\>|", "#<#", "#>#", "|&#39;|", '#&quot;#', '#&nbsp;#' );
  $html_entities_replace = array( "\n", '&lt;', '&gt;', "'", '"', ' ' );
  $tag = preg_replace( $html_entities_match, $html_entities_replace, $tag );
  $tag = str_replace('&lt;', '<', $tag);
  $tag = str_replace('&gt;', '>', $tag);
  $tag = str_replace( "\t", '  ', $tag);

$document->addCustomTag("<" . $tag . "/>");

}
?>